<?php

/**
 * Terminal - Mini Utils
 *
 * @version 1.1
 * @author Creative Pulse
 * @copyright Creative Pulse 2012-2014
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @link http://www.creativepulse.gr
 */


// configuration //////////////////////////////////////////

$config = array();

$config['url_password'] = ''; // default: <empty>

// end of configuration ///////////////////////////////////


$url_password = (string) @$config['url_password'];

if ($url_password != '' && !isset($_GET[$url_password])) {
	sleep(5);
	header('HTTP/1.0 403 Forbidden');
	echo
'<!DOCTYPE html>
<html>
<head><title>403 Forbidden</title></head>
<body><h1>Forbidden</h1><p>You don\'t have permission to access this service.</p></body>
</html>
';
	exit();
}

function json_esc($input, $esc_html = true) {
	$result = '';
	$conv = array("\x08" => '\\b', "\t" => '\\t', "\n" => '\\n', "\f" => '\\f', "\r" => '\\r', '"' => '\\"', "'" => "\\'", '\\' => '\\\\', '<' => '\\u003C', '>' => '\\u003E');
	for ($i = 0, $len = strlen($input); $i < $len; $i++) {
		if (isset($conv[$input[$i]])) {
			$result .= $conv[$input[$i]];
		}
		else if ($input[$i] < ' ') {
			$result .= sprintf('\\u%04x', ord($input[$i]));
		}
		else {
			$result .= $input[$i];
		}
	}
	return $result;
}

if (isset($_GET['cmd'])) {
	if (get_magic_quotes_gpc()) {
		$_GET['cmd'] = stripslashes($_GET['cmd']);
	}

	$output = '';
	$result = false;
	exec($_GET['cmd'], $output, $result);
	echo '({ "reqid" : "' . $_GET['reqid'] . '", "result" : "' . $result . '", "output" : "' . json_esc(htmlspecialchars(implode("\n", $output))) . '" })';
	exit();
}

if (in_array('exec', explode(',', @ini_get('disable_functions')))) {
	echo
'<!DOCTYPE html>
<html>
<head><title>Terminal is unable to run</title></head>
<body><h1>Terminal is unable to run</h1><p>This utility is unable to run because the function exec() is disabled in this web server.</p></body>
</html>
';
	exit();
}

?>
<!DOCTYPE html>

<html>
<head>
<title>Terminal - Mini Utils</title>
<meta charset="utf-8">

<style type="text/css">
body {
	font-family: Verdana, Arial, Helvetica, sans-serif;
	font-size: 11px;
	margin: 0;
}
.request, .request-success, .request-failure {
	background-color: #cc9;
	padding: 10px;
}
.request-success {
	background-color: #a5e89b;
}
.request-failure {
	background-color: #f1cccc;
}
.controls {
	float: right;
	margin-top: -3px;
}
.controls button {
	margin-left: 10px;
	cursor: pointer;
}
.response {
	padding: 10px;
	font-size: 1.2em;
}
pre {
	margin-bottom: 60px;
}
form {
	background-color: #ccc;
	padding: 15px;
	position: fixed;
	bottom: 0px;
	width: 100%;
	box-shadow: 0px 0px 10px rgba(0, 0, 0, 0.5);
}
table {
	margin: 0;
	width: 98%;
}
.tds {
	width: 1%;
	white-space: nowrap;
}
input[type=text] {
	width: 100%;
}
</style>

<script type="text/javascript">

function h_ajax_response() {
	if (ajax.readyState == 4) {
		if (ajax.status == 200) {
			var response = eval(ajax.responseText);
			var obj = document.getElementById("request_" + response.reqid);
			if (obj) {
				obj.className = response.result == 0 ? "request-success" : "request-failure";

				document.getElementById("response_" + response.reqid).innerHTML = response.output;

				window.location.hash = "request_" + response.reqid;
				document.forms.frm.cmd.focus();
				document.forms.frm.cmd.select();
			}
		}
		else {
			alert('HTTP error status ' + ajax.status + ":\n" + ajax.responseText);
		}

		ajax = null;
	}
}

var ajax = null, response_id = 0;

function send_cmd() {
	if (ajax != null) {
		alert("Another request is in progress");
		return;
	}

	if (window.XMLHttpRequest) {
		ajax = new window.XMLHttpRequest();
	}
	else if (window.ActiveXObject) {
		ajax = new window.ActiveXObject('Microsoft.XMLHTTP');
	}

	if (!ajax) {
		alert("Critical Error: Your browser was unable to initialize the AJAX sub-system");
	}
	else {
		var responses = document.getElementById("responses");
		response_id++;
	
		var frm = document.forms.frm;
		var cmd = frm.cmd.value;
		
		var div = document.createElement("div");
		div.className = "request";
		div.setAttribute("id", "request_" + response_id);
		responses.appendChild(div);
		
			var div_right = document.createElement("div");
			div_right.className = "controls";
			div.appendChild(div_right);

				var e = document.createTextNode("#" + response_id);
				div_right.appendChild(e);

				e = document.createElement("button");
				e.innerHTML = "x";
				div_right.appendChild(e);
				e.setAttribute("idx", response_id);
				e.onclick = function () {
					var idx = this.getAttribute("idx");
					var obj = document.getElementById("request_" + idx);
					obj.parentNode.removeChild(obj);
					var obj = document.getElementById("response_" + idx);
					obj.parentNode.removeChild(obj);
					document.forms.frm.cmd.focus();
					document.forms.frm.cmd.select();
				}
				
			div.appendChild(document.createTextNode(cmd.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;').replace(/\x22/g, '&quot;')));

		var div = document.createElement("div");
		div.className = "response";
		div.setAttribute("id", "response_" + response_id);
		responses.appendChild(div);
		
		var url = "terminal.php?reqid=" + response_id + "&cmd=" + encodeURIComponent(cmd) + "&t=" + (new Date()).getTime();
<?php
if ($url_password != '') {
	echo
'		url += "&' . urlencode($url_password) . '";
';
}
?>

		ajax.open("GET", url, true);
		ajax.onreadystatechange = h_ajax_response;
		ajax.send(null);
	}

	return false;
}

function clear_data() {
	var pre = document.getElementsByTagName('pre')[0];
	while (pre.firstChild) {
		pre.removeChild(pre.firstChild);
	}
	document.forms.frm.cmd.focus();
	document.forms.frm.cmd.select();
}

</script>

</head>

<body>

<pre id="responses"></pre>

<form name="frm" onsubmit="return send_cmd()">
	<table>
		<tr>
			<td class="tds">Command<td>
			<td><input name="cmd" type="text"><td>
			<td class="tds">
				<input type="submit" name="send" value="Send">
				<input type="button" onclick="clear_data()" value="Clear">
			<td>
		</tr>
	</table>
</form>

</body>

</html>
